// *******************************************************************
//   (C) Copyright 2014 Leiden Institute of Advanced Computer Science
//   Universiteit Leiden
//   All Rights Reserved
// *******************************************************************
// Tablut (core)
// *******************************************************************
// FILE INFORMATION:
//   File:     location.h
//   Author:   Jonathan K. Vis
//   Revision: 1.01a
//   Date:     2014/01/12
// *******************************************************************
// DESCRIPTION:
//   Defines the location coordinate constants.
// *******************************************************************

#if !defined(__location_h__)
#define __location_h__

#include "square.h"


static int const FILE_A = 0;
static int const FILE_B = 1;
static int const FILE_C = 2;
static int const FILE_D = 3;
static int const FILE_E = 4;
static int const FILE_F = 5;
static int const FILE_G = 6;
static int const FILE_H = 7;
static int const FILE_I = 8;

static int const RANK_1 = 8;
static int const RANK_2 = 7;
static int const RANK_3 = 6;
static int const RANK_4 = 5;
static int const RANK_5 = 4;
static int const RANK_6 = 3;
static int const RANK_7 = 2;
static int const RANK_8 = 1;
static int const RANK_9 = 0;


static Square const CAPTURED = Square(-1, -1);

static Square const A1 = Square(FILE_A, RANK_1);
static Square const A2 = Square(FILE_A, RANK_2);
static Square const A3 = Square(FILE_A, RANK_3);
static Square const A4 = Square(FILE_A, RANK_4);
static Square const A5 = Square(FILE_A, RANK_5);
static Square const A6 = Square(FILE_A, RANK_6);
static Square const A7 = Square(FILE_A, RANK_7);
static Square const A8 = Square(FILE_A, RANK_8);
static Square const A9 = Square(FILE_A, RANK_9);
static Square const B1 = Square(FILE_B, RANK_1);
static Square const B2 = Square(FILE_B, RANK_2);
static Square const B3 = Square(FILE_B, RANK_3);
static Square const B4 = Square(FILE_B, RANK_4);
static Square const B5 = Square(FILE_B, RANK_5);
static Square const B6 = Square(FILE_B, RANK_6);
static Square const B7 = Square(FILE_B, RANK_7);
static Square const B8 = Square(FILE_B, RANK_8);
static Square const B9 = Square(FILE_B, RANK_9);
static Square const C1 = Square(FILE_C, RANK_1);
static Square const C2 = Square(FILE_C, RANK_2);
static Square const C3 = Square(FILE_C, RANK_3);
static Square const C4 = Square(FILE_C, RANK_4);
static Square const C5 = Square(FILE_C, RANK_5);
static Square const C6 = Square(FILE_C, RANK_6);
static Square const C7 = Square(FILE_C, RANK_7);
static Square const C8 = Square(FILE_C, RANK_8);
static Square const C9 = Square(FILE_C, RANK_9);
static Square const D1 = Square(FILE_D, RANK_1);
static Square const D2 = Square(FILE_D, RANK_2);
static Square const D3 = Square(FILE_D, RANK_3);
static Square const D4 = Square(FILE_D, RANK_4);
static Square const D5 = Square(FILE_D, RANK_5);
static Square const D6 = Square(FILE_D, RANK_6);
static Square const D7 = Square(FILE_D, RANK_7);
static Square const D8 = Square(FILE_D, RANK_8);
static Square const D9 = Square(FILE_D, RANK_9);
static Square const E1 = Square(FILE_E, RANK_1);
static Square const E2 = Square(FILE_E, RANK_2);
static Square const E3 = Square(FILE_E, RANK_3);
static Square const E4 = Square(FILE_E, RANK_4);
static Square const E5 = Square(FILE_E, RANK_5);
static Square const E6 = Square(FILE_E, RANK_6);
static Square const E7 = Square(FILE_E, RANK_7);
static Square const E8 = Square(FILE_E, RANK_8);
static Square const E9 = Square(FILE_E, RANK_9);
static Square const F1 = Square(FILE_F, RANK_1);
static Square const F2 = Square(FILE_F, RANK_2);
static Square const F3 = Square(FILE_F, RANK_3);
static Square const F4 = Square(FILE_F, RANK_4);
static Square const F5 = Square(FILE_F, RANK_5);
static Square const F6 = Square(FILE_F, RANK_6);
static Square const F7 = Square(FILE_F, RANK_7);
static Square const F8 = Square(FILE_F, RANK_8);
static Square const F9 = Square(FILE_F, RANK_9);
static Square const G1 = Square(FILE_G, RANK_1);
static Square const G2 = Square(FILE_G, RANK_2);
static Square const G3 = Square(FILE_G, RANK_3);
static Square const G4 = Square(FILE_G, RANK_4);
static Square const G5 = Square(FILE_G, RANK_5);
static Square const G6 = Square(FILE_G, RANK_6);
static Square const G7 = Square(FILE_G, RANK_7);
static Square const G8 = Square(FILE_G, RANK_8);
static Square const G9 = Square(FILE_G, RANK_9);
static Square const H1 = Square(FILE_H, RANK_1);
static Square const H2 = Square(FILE_H, RANK_2);
static Square const H3 = Square(FILE_H, RANK_3);
static Square const H4 = Square(FILE_H, RANK_4);
static Square const H5 = Square(FILE_H, RANK_5);
static Square const H6 = Square(FILE_H, RANK_6);
static Square const H7 = Square(FILE_H, RANK_7);
static Square const H8 = Square(FILE_H, RANK_8);
static Square const H9 = Square(FILE_H, RANK_9);
static Square const I1 = Square(FILE_I, RANK_1);
static Square const I2 = Square(FILE_I, RANK_2);
static Square const I3 = Square(FILE_I, RANK_3);
static Square const I4 = Square(FILE_I, RANK_4);
static Square const I5 = Square(FILE_I, RANK_5);
static Square const I6 = Square(FILE_I, RANK_6);
static Square const I7 = Square(FILE_I, RANK_7);
static Square const I8 = Square(FILE_I, RANK_8);
static Square const I9 = Square(FILE_I, RANK_9);

static Square const CASTLE = E5;

#endif

