// *******************************************************************
//   (C) Copyright 2014 Leiden Institute of Advanced Computer Science
//   Universiteit Leiden
//   All Rights Reserved
// *******************************************************************
// Tablut (core)
// *******************************************************************
// FILE INFORMATION:
//   File:     pieces.h
//   Author:   Jonathan K. Vis
//   Revision: 1.01a
//   Date:     2014/01/13
// *******************************************************************
// DESCRIPTION:
//   Defines the pieces.
// *******************************************************************

#if !defined(__pieces_h__)
#define __pieces_h__

static int const NONE          =  0;
static int const WHITE_KING    =  1;
static int const WHITE_PAWN_0  =  2;
static int const WHITE_PAWN_1  =  3;
static int const WHITE_PAWN_2  =  4;
static int const WHITE_PAWN_3  =  5;
static int const WHITE_PAWN_4  =  6;
static int const WHITE_PAWN_5  =  7;
static int const WHITE_PAWN_6  =  8;
static int const WHITE_PAWN_7  =  9;
static int const BLACK_PAWN_0  = 10;
static int const BLACK_PAWN_1  = 11;
static int const BLACK_PAWN_2  = 12;
static int const BLACK_PAWN_3  = 13;
static int const BLACK_PAWN_4  = 14;
static int const BLACK_PAWN_5  = 15;
static int const BLACK_PAWN_6  = 16;
static int const BLACK_PAWN_7  = 17;
static int const BLACK_PAWN_8  = 18;
static int const BLACK_PAWN_9  = 19;
static int const BLACK_PAWN_10 = 20;
static int const BLACK_PAWN_11 = 21;
static int const BLACK_PAWN_12 = 22;
static int const BLACK_PAWN_13 = 23;
static int const BLACK_PAWN_14 = 24;
static int const BLACK_PAWN_15 = 25;


static inline bool is_pawn(int const piece)
{
  return piece >= WHITE_PAWN_0 && piece <= BLACK_PAWN_15;
} // is_pawn

static inline bool is_white_pawn(int const piece)
{
  return piece >= WHITE_PAWN_0 && piece <= WHITE_PAWN_7;
} // is_white_pawn

static inline bool is_black_pawn(int const piece)
{
  return piece >= BLACK_PAWN_0 && piece <= BLACK_PAWN_15;
} // is_black_pawn

static inline bool is_friendly_pawn(int const piece_a, int const piece_b)
{
  return is_pawn(piece_a) && is_pawn(piece_b) &&
         (is_white_pawn(piece_a) ? is_white_pawn(piece_b) : is_black_pawn(piece_b));
} // is_friendly_pawn

static inline bool is_enemy_pawn(int const piece_a, int const piece_b)
{
  return is_pawn(piece_a) && is_pawn(piece_b) &&
         (is_white_pawn(piece_a) ? is_black_pawn(piece_b) : is_white_pawn(piece_b));
} // is_enemy_pawn

#endif

