// *******************************************************************
//   (C) Copyright 2014 Leiden Institute of Advanced Computer Science
//   Universiteit Leiden
//   All Rights Reserved
// *******************************************************************
// Tablut (core)
// *******************************************************************
// FILE INFORMATION:
//   File:     square.h
//   Author:   Jonathan K. Vis
//   Revision: 1.01a
//   Date:     2014/01/12
// *******************************************************************
// DESCRIPTION:
//   Defines a square (rank and file) on the Tablut board.
// *******************************************************************

#if !defined(__square_h__)
#define __square_h__

struct Square
{
  explicit inline Square(void) { }

  explicit inline Square(int const file, int const rank):
                    file(file), rank(rank) { }


  bool operator==(Square const &square) const;
  bool operator!=(Square const &square) const;


  int file;
  int rank;

}; // Square


inline bool Square::operator==(Square const &square) const
{
  return file == square.file && rank == square.rank;
} // Square::operator==

inline bool Square::operator!=(Square const &square) const
{
  return !(*this == square);
} // Square::operator==

#endif

