// *******************************************************************
//   (C) Copyright 2014 Leiden Institute of Advanced Computer Science
//   Universiteit Leiden
//   All Rights Reserved
// *******************************************************************
// Tablut (engine)
// *******************************************************************
// FILE INFORMATION:
//   File:     search.h (implemented in evaluation.cc and search.cc)
//   Author:   Jonathan K. Vis
//   Revision: 1.01a
//   Date:     2014/01/14
// *******************************************************************
// DESCRIPTION:
//   Search functions.
// *******************************************************************

#if !defined(__search_h__)
#define __search_h__

#include "../core/position.h"
#include "../interface/jlkiss64.h"


struct Search_Parameters
{
  Position* position;
  int       max_depth;
  Move*     move;
  int       value;
}; // Search_Paramaters


extern volatile bool terminate_search; // in search.cc


int evaluate(Position const &position);

int iterative_deepening(Position &position, int const max_depth, Move &move);

uint64_t perft(Position &position, int const depth);

#endif

